# coding=utf-8
from django.db import models


class Avaibility(models.Model):
    class Meta:
        app_label = 'web'

    person = models.ForeignKey("web.Worker", on_delete=models.CASCADE,
                               verbose_name='Worker'
                               )
    day_number = models.IntegerField(
        verbose_name='Day of the week'
    )
    available_from = models.TimeField(
        verbose_name='Avaible since'
    )
    available_till = models.TimeField(
        verbose_name='Avaible until'
    )
    is_current = models.BooleanField(
        verbose_name='Is current?',
        default=True
    )

    def __str__(self):
        return "%d %s %s" % (self.day_number, self.person.last_name, self.person.first_name)

    def __unicode__(self):
        return "%d %s %s" % (self.day_number, self.person.last_name, self.person.first_name)
