# coding=utf-8
from django.test import Client
from django.test import TestCase
from django.urls import reverse

from functions import create_user
from web.models import Worker


class TestLoginView(TestCase):
    def test_login(self):
        self.client = Client()
        user = create_user()
        password = 'top_secret'
        username = user.username
        login_url = reverse('web.views.login')
        response = self.client.post(login_url, data={'username': username, 'password': password}, follow=True)
        self.assertEqual(200, response.status_code)
        worker = Worker.get_by_user(user)
        self.assertIsNotNone(worker)
        worker.last_name = 'Grouès'
        worker.save()
        response = self.client.post(login_url, data={'username': username, 'password': password}, follow=True)
        self.assertEqual(200, response.status_code)
