# coding=utf-8
from datetime import datetime

from django.contrib.auth.models import User
from django.test import Client
from django.test import TestCase
from django.urls import reverse

__author__ = 'Valentin Grouès'


class TestStatisticsView(TestCase):
    def setUp(self):
        self.client = Client()
        username = 'piotr'
        password = 'top_secret'
        self.user = User.objects.create_user(
            username=username, email='jacob@bla', password=password)
        self.client.login(username=username, password=password)

    def test_statistics_request(self):
        url = reverse('web.views.statistics')
        response = self.client.get(url)
        self.assertEqual(response.status_code, 200)
        current_month = datetime.now().month - 1 or 12
        content = response.content
        self.assertIn('<option value="{}" selected="selected">'.format(current_month), content)
        response = self.client.get(url, {"month": 10, "year": 2017, "subject_type": -1, "visit": -1})
        content = response.content
        self.assertIn('<option value="10" selected="selected">October', content)
